<template>
  <div>
    <label :for="field">
      {{ label }}
      <span v-if="required" aria-hidden="true" class="text-red-error">*</span>
    </label>
    <input
      :id="field"
      v-model.trim="name"
      type="text"
      class="form-input block mt-1 w-full"
      :required="required"
      @blur="$emit('blur', { field, value: name })"
    />
    <slot />
  </div>
</template>

<script>
export default {
  name: 'ANameField',
  props: {
    label: { type: String, default: 'Nom' },
    validation: { type: String, default: 'required|regex:/^[a-zÀ-ÿ\\s]+$/i' },
  },
  data: () => ({
    fid: 'name',
    name: null,
  }),
  computed: {
    field() {
      return this.$vnode.data.ref;
    },
    required() {
      return /required/.test(this.validation);
    },
  },
  methods: {
    reset() {
      this.name = null;
    },
  },
};
</script>
